#ifndef _ENTRY_CPP
#define _ENTRY_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"

#include "../../SharedSource/NSWFL.H"
#include "../../SharedSource/Debug.H"
#include "../../SharedSource/Common.H"

#include "Entry.H"
#include "Init.H"
#include "Routines.H"
#include "WinService.H"
#include "Console.H"

#include "../CSockSrvr/CSockSrvr.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HINSTANCE ghAppInstance = NULL;

char gsAppCopyRight[64];
char gsFileVersion[32];
char gsTitleCaption[64];
char gsRegistryKey[255];

bool gbIsMainDialogOpen = false;
bool gbDebugMode = false;

NASCCL gCrypt;

_MainDialogInfo MDI;
_ConnectedClientInfo CCI;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevious, LPSTR sCmdLine, int iCmdShow)
//int main(void)
{
	int iReturnVal = 0;

	ghAppInstance = hInstance;
	//ghAppInstance = GetModuleHandle(NULL);

	if(!InitializeApp())
    {
        return 1;
    }

	if(strlen(sCmdLine) > 0)
	{
		CCmdLine MyCmd;

		if(MyCmd.Init())
		{
			iReturnVal = ProcessCommandLine(&MyCmd);
		}

		MyCmd.Destroy();
	}
	else{
		iReturnVal = StartRoutine("/NonService");
	}

	if(!UninitializeApp())
    {
        return 1;
    }

	return iReturnVal;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ProcessCommandLine(CCmdLine *lpCmd)
{
	int iArg = 0;
	int iArgSz = 0;
	char *sArg = NULL;
	char *sMsg = NULL;

	while(iArg < lpCmd->iArgCount)
	{
		sArg = "/AutoConnect";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			gbAutoConnect = true;
		}

		sArg = "/Account:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsCompanyName);
		}

		sArg = "/Password:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsCompanyPassword);
			MsgBox(gsCompanyName);
		}

		sArg = "/SQLDriver:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsSQLDriver);
			MsgBox(gsCompanyName);
		}

		sArg = "/SQLPassword:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsSQLPassword);
			MsgBox(gsCompanyName);
		}

		sArg = "/SQLServer:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsSQLServer);
			MsgBox(gsCompanyName);
		}

		sArg = "/SQLUserID:";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArgs[iArg], iArgSz, lpCmd->iArgLens[iArg], gsSQLUserID);
			MsgBox(gsCompanyName);
		}

		sArg = "/NonService";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			return StartRoutine(sArg);
		}

		sArg = "/RunService";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			return StartRoutine(sArg);
		}

		sArg = "/OpenConsole";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
   			if( IsServiceInstalled() == _No_ )
   			{
       			MessageBox(NULL, "The service is not installed.", gsTitleCaption, MB_ICONINFORMATION );
   				return 0;
			}

			if(IsServiceActive() == _No_)
			{
				if(MessageBox(NULL, "The service is not started. Would you like to start it now?", gsTitleCaption, MB_YESNO|MB_APPLMODAL) == IDNO)
				{
					return 0;
				}

    			if(StartService() == _Success_)
				{
		//    		MessageBox(NULL, "The service was started sucessfully.", gsTitleCaption, MB_ICONINFORMATION );
				}
				else{
        			MessageBox(NULL, "Failed to start the service.", gsTitleCaption, MB_ICONINFORMATION );
       				return 0;
				}
			}

			if(TriggerEvent(OpenServerConsoleEventName) != _Success_)
			{
				MessageBox(NULL, "Failed to modify service event state.", gsTitleCaption, MB_ICONINFORMATION );
			}

			return 0;
		}

		sArg = "/OpenMainDialog";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
   			if( IsServiceInstalled() == _No_ )
   			{
       			MessageBox(NULL, "The service is not installed.", gsTitleCaption, MB_ICONINFORMATION );
   				return 0;
			}

			if(IsServiceActive() == _No_)
			{
				if(MessageBox(NULL, "The service is not started. Would you like to start it now?", gsTitleCaption, MB_YESNO|MB_APPLMODAL) == IDNO)
				{
					return 0;
				}

    			if(StartService() == _Success_)
				{
		//    		MessageBox(NULL, "The service was started sucessfully.", gsTitleCaption, MB_ICONINFORMATION );
				}
				else{
        			MessageBox(NULL, "Failed to start the service.", gsTitleCaption, MB_ICONINFORMATION );
       				return 0;
				}
			}

			if(TriggerEvent(OpenMainDialogEventName) != _Success_)
			{
				MessageBox(NULL, "Failed to modify service event state.", gsTitleCaption, MB_ICONINFORMATION );
			}

			return 0;
		}

		sArg = "/Install";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			char Application[257];
			char sSrvcCmdLine[MAX_PATH];

    		short ServiceInstalled = IsServiceInstalled();

			if( ServiceInstalled == _Yes_ )
			{
    			//MessageBox(NULL, "The service is already installed.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

			GetModuleFileName(ghAppInstance, Application, MAX_PATH);

			sprintf(sSrvcCmdLine, "%s /RunService", Application);

			if ( InstallService(sSrvcCmdLine) == _Success_ )
			{
	//			MessageBox(NULL, "The service was installed sucessfully.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}
			else{
				MessageBox(NULL, "Failed to install the service.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

			return 0;
		}

		sArg = "/Start";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			if( IsServiceInstalled() == _No_ )
			{
    			MessageBox(NULL, "The service is not installed.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

			if(IsServiceActive() == _Yes_)
			{
	//    		MessageBox(NULL, "The service is already active.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

			if(StartService() == _Success_)
			{
	//    		MessageBox(NULL, "The service was started sucessfully.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}
			else{
    			MessageBox(NULL, "Failed to start the service.", gsTitleCaption, MB_ICONINFORMATION );
   				return 0;
			}

			return 0;
		}

		sArg = "/Delete";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			if( IsServiceInstalled() == _No_ )
			{
	//    		MessageBox(NULL, "The service is not installed.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

			if(IsServiceActive() == _Yes_)
			{
				CommandService(SERVICE_CONTROL_STOP); // Failure would not be an error.
				return 0;
			}

    		if( UninstallService() == _Success_ )
    		{
	//    		MessageBox(NULL, "The service was marked for deletion.", gsTitleCaption, MB_ICONINFORMATION );
    			return 0;
       		}
			else{
    			MessageBox(NULL, "Failed to mark the service for deletion.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

			return 0;
		}

		sArg = "/Stop";
		iArgSz = strlen(sArg);
		if(strnicmp(lpCmd->sArgs[iArg], sArg, iArgSz) == 0)
		{
			if( IsServiceInstalled() == _No_ )
			{
	//    		MessageBox(NULL, "The service is not installed.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

			if(IsServiceActive() == _No_)
			{
	//    		MessageBox(NULL, "The service is already stopped.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}

    		if( CommandService(SERVICE_CONTROL_STOP) == _Success_ )
    		{
	//    		MessageBox(NULL, "The service was stopped.", gsTitleCaption, MB_ICONINFORMATION );
    			return 0;
       		}
			else{
    			MessageBox(NULL, "Failed to stop the service.", gsTitleCaption, MB_ICONINFORMATION );
				return 0;
			}
			return 0;
		}

		iArg++;
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int StartRoutine(char *sCmdLine)
{
	if(strcmpi(sCmdLine, "/RunService") == 0)
	{
		int Length		   = 0;
		short Result	   = 0;
		LONG LastError     = 0;
		HANDLE MutexHandle = NULL;

		gbRunningAsService = true;

		if(IsWinNT() != true)
		{
			MessageBox(NULL, "This application was designed to run only on NT based systems.", gsTitleCaption, MB_SYSTEMMODAL + MB_TASKMODAL);
			return _Error_;
		}

		//-------------------------------------------------------------------------------

		SECURITY_DESCRIPTOR SD;
   		SECURITY_ATTRIBUTES SA;

   		if(InitializeSecurityDescriptor(&SD, SECURITY_DESCRIPTOR_REVISION) == FALSE)
   			return _Error_;

   		if(SetSecurityDescriptorDacl(&SD, TRUE, 0, FALSE) == FALSE)
   			return _Error_;

   		SA.nLength				= sizeof(SA);
   		SA.lpSecurityDescriptor = &SD;
   		SA.bInheritHandle		= FALSE;
		MutexHandle = CreateMutex(&SA, FALSE, gsTitleCaption);

		LastError = GetLastError();
		if(MutexHandle != 0)
		{
			if(LastError == ERROR_ALREADY_EXISTS)
			{
				MessageBox(NULL, "Application already running.", gsTitleCaption, MB_SYSTEMMODAL + MB_TASKMODAL);
				WriteSysLogEx("Application already running.", EVENT_ERROR);
				return _Error_;
			}
		}

		//-------------------------------------------------------------------------------

		Result = ServiceEntry();

		if(Result == _Success_)
		{
    		ReleaseMutex(MutexHandle);
    		CloseHandle(MutexHandle);

			return(_Success_);
		}
		else if(Result == _Error_)
		{
    		ReleaseMutex(MutexHandle);
    		CloseHandle(MutexHandle);

			return(_Error_);
		}
	}
	else{
		if(strcmpi(sCmdLine, "/NonService") == 0)
		{
			gbRunningAsService = false;
			hServiceThread_Handle = CreateThread(NULL ,0, ServiceThread,(LPVOID)0, 0, &dwServiceThread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), 0, MainDialog);
			WaitOnApplicationToExit();
			return _Success_;
		}
	}
	return _Error_;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool MainEntry(void)
{
    gbApplicationRunning = true;

	WriteSysLogEx("Client started.", EVENT_INFO);

	if(!gServer.Start())
	{
		WriteSysLogEx("Failed to start the client.", EVENT_ERROR);
		gbApplicationRunning = false;
		return false;
	}

	Timer_Thread_Handle = CreateThread(NULL, 0, Timer_Thread, (LPVOID)0, 0, &Timer_Thread_ID);

	while(!gbKillApplication)
    {
    	if(WaitForSingleObject(hOpenMainDialog_Handle, 0) == WAIT_OBJECT_0)
        {
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
        }

    	if(WaitForSingleObject(hOpenConsole_Handle, 0) == WAIT_OBJECT_0)
        {
			//Not implemented.
        }

		Sleep(1);
    }
	WriteSysLogEx("Client Stopped.", EVENT_INFO);

    if(!gServer.Stop())
	{
		WriteSysLogEx("Failed to stop the client.", EVENT_ERROR);
	    gbApplicationRunning = false;
		return false;
	}

	gbApplicationRunning = false;
    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif

